(* SendFile - 21.04.91 - MOLINARI Gilles - Turbo Pascal 3.00A CP/M 80
**
** Sending file from CPC6128 to a remote PC running getfile, by // port, with 
** an half-byte transfert.
**
** Program was tested under CP/M Plus, not CP/M 2.2
**
** THIS PROGRAM IS FREEWARE **
 
INTERFACE
---------
 
. CPC -> PC
 
 port $EFxx 76543210
	    ||||+---- bit 0
	    |||+----- bit 1
	    ||+------ bit 2
	    |+------- bit 3
	    +-------- Data available
 
. PC -> CPC
 
 port $F5xx 76543210
	     +------- Ready to receive
*)
 
program SendFile;
type
  t_filename=string[80];
var
  fich:file;
  buff:array[0..127] of byte;
  i,j,n:integer;
 
Procedure sendbyte(oct:integer);
Begin
InLine ($3A/OCT
/$57
/$07
/$07
/$07
/$CD/*+$0004
/$7A
/$0F
/$E6/$78
/$5F
/$01/$00/$F5
/$ED/$78
/$E6/$40
/$28/$FA
/$06/$EF
/$ED/$59
/$CB/$FB
/$ED/$59
/$06/$F5
/$ED/$78
/$E6/$40
/$20/$FA
/$06/$EF
/$ED/$49
)
End;
 
  procedure sendrequest(str:t_filename;nh,nl:integer);
  var
    i:integer;
  begin
    i:=pos(':',str);
    if i>0 then delete(str,1,i);
    for i:=0 to ord(str[0]) do sendbyte(ord(str[i]));
    sendbyte(lo(nl));
    sendbyte(hi(nl));
    sendbyte(lo(nh));
    sendbyte(hi(nh));
  end;
 
begin
  if ParamCount<>1 then begin
    writeln('Usage = SENDFILE filename');
    halt;
  end;
  assign(fich,paramstr(1));
  {$I-}
  reset(fich);
  {$I+}
  i:=IOResult;
  if i<>0 then begin
    writeln('Error ',i,' while opening file ',paramstr(1));
    halt;
  end;
  Port[$32]:=0;
  i:=0;
  n:=filesize(fich);
  sendrequest(paramstr(1),0,n);
  while not eof(fich) do begin
    i:=succ(i);
    if (i and $0f)=0 then write('.');
    blockread(fich,buff,1);
    for j:=0 to 127 do
      sendbyte(buff[j]);
  end;
  clreol;
  close(fich);
end.
 
(* ----------------------------- *)
M 80
**
** Sending file from CPC6128 to a remote PC running g